﻿using Microsoft.Owin.Security.OAuth;
using System.Web.Http;

namespace CloudReporting.MVC
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            // Web API configuration and services
            // Configure Web API to use only bearer token authentication.
            config.SuppressDefaultHostAuthentication();
            config.Filters.Add(new HostAuthenticationFilter(OAuthDefaults.AuthenticationType));

            // Web API routes
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "statusUpdatesApi",
                routeTemplate: "api/{controller}/{sessionId}/",
                defaults: new { },
                constraints: new { sessionId = @"^[{(]?[0-9A-F]{8}[-]?([0-9A-F]{4}[-]?){3}[0-9A-F]{12}[)}]?$" } //must be a Guid
            );

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{category}/{format}/{email}/{sessionId}/",
                defaults: new
                {
                    category = RouteParameter.Optional,
                    format = RouteParameter.Optional,
                    email = RouteParameter.Optional,
                    sessionId = RouteParameter.Optional
                }
            );
        }
    }
}
